<h1>Weaviate <img alt='Weaviate logo' src='https://raw.githubusercontent.com/semi-technologies/weaviate/19de0956c69b66c5552447e84d016f4fe29d12c9/docs/assets/weaviate-logo.png' width='52' align='right' /></h1>

[![Build Status](https://api.travis-ci.org/semi-technologies/weaviate.svg?branch=master)](https://travis-ci.org/semi-technologies/weaviate/branches)
[![Go Report Card](https://goreportcard.com/badge/github.com/semi-technologies/weaviate)](https://goreportcard.com/report/github.com/semi-technologies/weaviate)
[![Coverage Status](https://codecov.io/gh/semi-technologies/weaviate/branch/master/graph/badge.svg)](https://codecov.io/gh/semi-technologies/weaviate)
[![Slack](https://img.shields.io/badge/slack--channel-blue?logo=slack)](https://codecov.io/gh/semi-technologies/weaviate)
[![Newsletter](https://img.shields.io/badge/newsletter-blue?logo=mailchimp)](https://www.semi.technology/newsletter/)


<a href="https://semi.technology/documentation/weaviate/current/" target="_blank"><img src="https://www.semi.technology/img/weaviate-demo.gif?i=4" alt="Demo of Weaviate" width="100%"></a>

## Description

Weaviate is a cloud-native, realtime vector search engine that allows you to bring your machine learning models to scale. There are extensions for specific use cases such as semantic search, plugins to integrate Weaviate in any application of your choice and a console to visualize your data.

_GraphQL - RESTful - vector search engine - semantic search - HNSW - deep search - machine learning - kNN_

## Documentation

- [Documentation](https://semi.technology/documentation/weaviate/current/)
  - Installation
    - [Docker Compose](https://semi.technology/documentation/weaviate/current/getting-started/installation.html#docker-compose)
    - [Cloud Deployment](https://semi.technology/documentation/weaviate/current/getting-started/installation.html#cloud-deployment)
    - [Weaviate Cluster Service (beta)](https://semi.technology/documentation/weaviate/current/getting-started/installation.html#weaviate-cluster-service)
    - [Kubernetes](https://semi.technology/documentation/weaviate/current/getting-started/installation.html#kubernetes)
  - Client Libraries
    - [Python](https://semi.technology/documentation/weaviate/current/client-libraries/python.html)
    - [JavaScript](https://semi.technology/documentation/weaviate/current/client-libraries/javascript.html)
  - [How To's](https://semi.technology/documentation/weaviate/current/how-tos/)
  - [RESTful API references](https://semi.technology/documentation/weaviate/current/restful-api-references/)
  - [GraphQL references](https://semi.technology/documentation/weaviate/current/graphql-references/)
  - [More resources](https://semi.technology/documentation/weaviate/current/more-resources/)

## Support

- [Stackoverflow for questions](https://stackoverflow.com/questions/tagged/weaviate)
- [Github for issues](https://github.com/semi-technologies/weaviate/issues)
- [Slack channel](https://join.slack.com/t/weaviate/shared_invite/zt-goaoifjr-o8FuVz9b1HLzhlUfyfddhw)

## Contributing

- [How to Contribute](https://www.semi.technology/documentation/contributor-guide/current/)
