//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Package descriptions provides the descriptions as used by the graphql endpoint for Weaviate
package descriptions

// Local
const (
	LocalMergeActions = "Merge Actions on a local Weaviate"
	LocalMergeThings  = "Merge Things on a local Weaviate"
)

const (
	LocalMergeObj = "An object used to Merge Things or Actions on a local Weaviate"
	LocalMerge    = "Merge Things or Actions on a local Weaviate"
)

const LocalMergeThingsActionsObj = "An object used to get %ss on a local Weaviate"

const LocalMergeClassUUID = "The UUID of a Thing or Action, assigned by its local Weaviate"

// Network
const (
	NetworkMerge    = "Merge Things or Actions from a Weaviate in a network"
	NetworkMergeObj = "An object used to Merge Things or Actions from a Weaviate in a network"
)

const NetworkMergeWeaviateObj = "An object containing Merge Things and Actions fields for network Weaviate instance: "

const (
	NetworkMergeActions = "Merge Actions from a Weaviate in a network"
	NetworkMergeThings  = "Merge Things from a Weaviate in a network"
)

const (
	NetworkMergeActionsObj = "An object containing the Actions objects on this network Weaviate instance."
	NetworkMergeThingsObj  = "An object containing the Things objects on this network Weaviate instance."
)

const NetworkMergeClassUUID = "The UUID of a Thing or Action, assigned by the Weaviate network" // TODO check this with @lauraham
