//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package batching

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"encoding/json"
	"net/http"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/semi-technologies/weaviate/entities/models"
)

// BatchingThingsCreateHandlerFunc turns a function with the right signature into a batching things create handler
type BatchingThingsCreateHandlerFunc func(BatchingThingsCreateParams, *models.Principal) middleware.Responder

// Handle executing the request and returning a response
func (fn BatchingThingsCreateHandlerFunc) Handle(params BatchingThingsCreateParams, principal *models.Principal) middleware.Responder {
	return fn(params, principal)
}

// BatchingThingsCreateHandler interface for that can handle valid batching things create params
type BatchingThingsCreateHandler interface {
	Handle(BatchingThingsCreateParams, *models.Principal) middleware.Responder
}

// NewBatchingThingsCreate creates a new http.Handler for the batching things create operation
func NewBatchingThingsCreate(ctx *middleware.Context, handler BatchingThingsCreateHandler) *BatchingThingsCreate {
	return &BatchingThingsCreate{Context: ctx, Handler: handler}
}

/*BatchingThingsCreate swagger:route POST /batching/things batching things batchingThingsCreate

Creates new Things based on a Thing template as a batch.

Register new Things in bulk. Provided meta-data and schema values are validated.

*/
type BatchingThingsCreate struct {
	Context *middleware.Context
	Handler BatchingThingsCreateHandler
}

func (o *BatchingThingsCreate) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewBatchingThingsCreateParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *models.Principal
	if uprinc != nil {
		principal = uprinc.(*models.Principal) // this is really a models.Principal, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// BatchingThingsCreateBody batching things create body
//
// swagger:model BatchingThingsCreateBody
type BatchingThingsCreateBody struct {

	// Define which fields need to be returned. Default value is ALL
	Fields []*string `yaml:"fields" json:"fields"`

	// things
	Things []*models.Thing `yaml:"things" json:"things"`
}

// Validate validates this batching things create body
func (o *BatchingThingsCreateBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateFields(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateThings(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var batchingThingsCreateBodyFieldsItemsEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ALL","class","schema","id","creationTimeUnix"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		batchingThingsCreateBodyFieldsItemsEnum = append(batchingThingsCreateBodyFieldsItemsEnum, v)
	}
}

func (o *BatchingThingsCreateBody) validateFieldsItemsEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, batchingThingsCreateBodyFieldsItemsEnum, true); err != nil {
		return err
	}
	return nil
}

func (o *BatchingThingsCreateBody) validateFields(formats strfmt.Registry) error {

	if swag.IsZero(o.Fields) { // not required
		return nil
	}

	for i := 0; i < len(o.Fields); i++ {
		if swag.IsZero(o.Fields[i]) { // not required
			continue
		}

		// value enum
		if err := o.validateFieldsItemsEnum("body"+"."+"fields"+"."+strconv.Itoa(i), "body", *o.Fields[i]); err != nil {
			return err
		}

	}

	return nil
}

func (o *BatchingThingsCreateBody) validateThings(formats strfmt.Registry) error {

	if swag.IsZero(o.Things) { // not required
		return nil
	}

	for i := 0; i < len(o.Things); i++ {
		if swag.IsZero(o.Things[i]) { // not required
			continue
		}

		if o.Things[i] != nil {
			if err := o.Things[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("body" + "." + "things" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *BatchingThingsCreateBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *BatchingThingsCreateBody) UnmarshalBinary(b []byte) error {
	var res BatchingThingsCreateBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
