//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package contextionary_api

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/semi-technologies/weaviate/entities/models"
)

// C11yConceptsOKCode is the HTTP code returned for type C11yConceptsOK
const C11yConceptsOKCode int = 200

/*C11yConceptsOK Successful response.

swagger:response c11yConceptsOK
*/
type C11yConceptsOK struct {

	/*
	  In: Body
	*/
	Payload *models.C11yWordsResponse `json:"body,omitempty"`
}

// NewC11yConceptsOK creates C11yConceptsOK with default headers values
func NewC11yConceptsOK() *C11yConceptsOK {

	return &C11yConceptsOK{}
}

// WithPayload adds the payload to the c11y concepts o k response
func (o *C11yConceptsOK) WithPayload(payload *models.C11yWordsResponse) *C11yConceptsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the c11y concepts o k response
func (o *C11yConceptsOK) SetPayload(payload *models.C11yWordsResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *C11yConceptsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// C11yConceptsBadRequestCode is the HTTP code returned for type C11yConceptsBadRequest
const C11yConceptsBadRequestCode int = 400

/*C11yConceptsBadRequest Incorrect request

swagger:response c11yConceptsBadRequest
*/
type C11yConceptsBadRequest struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewC11yConceptsBadRequest creates C11yConceptsBadRequest with default headers values
func NewC11yConceptsBadRequest() *C11yConceptsBadRequest {

	return &C11yConceptsBadRequest{}
}

// WithPayload adds the payload to the c11y concepts bad request response
func (o *C11yConceptsBadRequest) WithPayload(payload *models.ErrorResponse) *C11yConceptsBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the c11y concepts bad request response
func (o *C11yConceptsBadRequest) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *C11yConceptsBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// C11yConceptsUnauthorizedCode is the HTTP code returned for type C11yConceptsUnauthorized
const C11yConceptsUnauthorizedCode int = 401

/*C11yConceptsUnauthorized Unauthorized or invalid credentials.

swagger:response c11yConceptsUnauthorized
*/
type C11yConceptsUnauthorized struct {
}

// NewC11yConceptsUnauthorized creates C11yConceptsUnauthorized with default headers values
func NewC11yConceptsUnauthorized() *C11yConceptsUnauthorized {

	return &C11yConceptsUnauthorized{}
}

// WriteResponse to the client
func (o *C11yConceptsUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(401)
}

// C11yConceptsForbiddenCode is the HTTP code returned for type C11yConceptsForbidden
const C11yConceptsForbiddenCode int = 403

/*C11yConceptsForbidden Forbidden

swagger:response c11yConceptsForbidden
*/
type C11yConceptsForbidden struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewC11yConceptsForbidden creates C11yConceptsForbidden with default headers values
func NewC11yConceptsForbidden() *C11yConceptsForbidden {

	return &C11yConceptsForbidden{}
}

// WithPayload adds the payload to the c11y concepts forbidden response
func (o *C11yConceptsForbidden) WithPayload(payload *models.ErrorResponse) *C11yConceptsForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the c11y concepts forbidden response
func (o *C11yConceptsForbidden) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *C11yConceptsForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// C11yConceptsInternalServerErrorCode is the HTTP code returned for type C11yConceptsInternalServerError
const C11yConceptsInternalServerErrorCode int = 500

/*C11yConceptsInternalServerError An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.

swagger:response c11yConceptsInternalServerError
*/
type C11yConceptsInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewC11yConceptsInternalServerError creates C11yConceptsInternalServerError with default headers values
func NewC11yConceptsInternalServerError() *C11yConceptsInternalServerError {

	return &C11yConceptsInternalServerError{}
}

// WithPayload adds the payload to the c11y concepts internal server error response
func (o *C11yConceptsInternalServerError) WithPayload(payload *models.ErrorResponse) *C11yConceptsInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the c11y concepts internal server error response
func (o *C11yConceptsInternalServerError) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *C11yConceptsInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// C11yConceptsNotImplementedCode is the HTTP code returned for type C11yConceptsNotImplemented
const C11yConceptsNotImplementedCode int = 501

/*C11yConceptsNotImplemented Not (yet) implemented.

swagger:response c11yConceptsNotImplemented
*/
type C11yConceptsNotImplemented struct {
}

// NewC11yConceptsNotImplemented creates C11yConceptsNotImplemented with default headers values
func NewC11yConceptsNotImplemented() *C11yConceptsNotImplemented {

	return &C11yConceptsNotImplemented{}
}

// WriteResponse to the client
func (o *C11yConceptsNotImplemented) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(501)
}
