//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package contextionary_api

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"

	"github.com/semi-technologies/weaviate/entities/models"
)

// C11yExtensionsHandlerFunc turns a function with the right signature into a c11y extensions handler
type C11yExtensionsHandlerFunc func(C11yExtensionsParams, *models.Principal) middleware.Responder

// Handle executing the request and returning a response
func (fn C11yExtensionsHandlerFunc) Handle(params C11yExtensionsParams, principal *models.Principal) middleware.Responder {
	return fn(params, principal)
}

// C11yExtensionsHandler interface for that can handle valid c11y extensions params
type C11yExtensionsHandler interface {
	Handle(C11yExtensionsParams, *models.Principal) middleware.Responder
}

// NewC11yExtensions creates a new http.Handler for the c11y extensions operation
func NewC11yExtensions(ctx *middleware.Context, handler C11yExtensionsHandler) *C11yExtensions {
	return &C11yExtensions{Context: ctx, Handler: handler}
}

/*C11yExtensions swagger:route POST /c11y/extensions/ contextionary-API c11yExtensions

Extend the contextionary with custom concepts

Extend the contextionary with your own custom concepts

*/
type C11yExtensions struct {
	Context *middleware.Context
	Handler C11yExtensionsHandler
}

func (o *C11yExtensions) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewC11yExtensionsParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *models.Principal
	if uprinc != nil {
		principal = uprinc.(*models.Principal) // this is really a models.Principal, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
