//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package things

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"

	"github.com/semi-technologies/weaviate/entities/models"
)

// ThingsValidateHandlerFunc turns a function with the right signature into a things validate handler
type ThingsValidateHandlerFunc func(ThingsValidateParams, *models.Principal) middleware.Responder

// Handle executing the request and returning a response
func (fn ThingsValidateHandlerFunc) Handle(params ThingsValidateParams, principal *models.Principal) middleware.Responder {
	return fn(params, principal)
}

// ThingsValidateHandler interface for that can handle valid things validate params
type ThingsValidateHandler interface {
	Handle(ThingsValidateParams, *models.Principal) middleware.Responder
}

// NewThingsValidate creates a new http.Handler for the things validate operation
func NewThingsValidate(ctx *middleware.Context, handler ThingsValidateHandler) *ThingsValidate {
	return &ThingsValidate{Context: ctx, Handler: handler}
}

/*ThingsValidate swagger:route POST /things/validate things thingsValidate

Validate Things schema.

Validate a Thing's schema and meta-data. It has to be based on a schema, which is related to the given Thing to be accepted by this validation.

*/
type ThingsValidate struct {
	Context *middleware.Context
	Handler ThingsValidateHandler
}

func (o *ThingsValidate) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewThingsValidateParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *models.Principal
	if uprinc != nil {
		principal = uprinc.(*models.Principal) // this is really a models.Principal, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
