//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// NewActionsCreateParams creates a new ActionsCreateParams object
// with the default values initialized.
func NewActionsCreateParams() *ActionsCreateParams {
	var ()
	return &ActionsCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewActionsCreateParamsWithTimeout creates a new ActionsCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewActionsCreateParamsWithTimeout(timeout time.Duration) *ActionsCreateParams {
	var ()
	return &ActionsCreateParams{

		timeout: timeout,
	}
}

// NewActionsCreateParamsWithContext creates a new ActionsCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewActionsCreateParamsWithContext(ctx context.Context) *ActionsCreateParams {
	var ()
	return &ActionsCreateParams{

		Context: ctx,
	}
}

// NewActionsCreateParamsWithHTTPClient creates a new ActionsCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewActionsCreateParamsWithHTTPClient(client *http.Client) *ActionsCreateParams {
	var ()
	return &ActionsCreateParams{
		HTTPClient: client,
	}
}

/*ActionsCreateParams contains all the parameters to send to the API endpoint
for the actions create operation typically these are written to a http.Request
*/
type ActionsCreateParams struct {

	/*Body*/
	Body *models.Action

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the actions create params
func (o *ActionsCreateParams) WithTimeout(timeout time.Duration) *ActionsCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the actions create params
func (o *ActionsCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the actions create params
func (o *ActionsCreateParams) WithContext(ctx context.Context) *ActionsCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the actions create params
func (o *ActionsCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the actions create params
func (o *ActionsCreateParams) WithHTTPClient(client *http.Client) *ActionsCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the actions create params
func (o *ActionsCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the actions create params
func (o *ActionsCreateParams) WithBody(body *models.Action) *ActionsCreateParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the actions create params
func (o *ActionsCreateParams) SetBody(body *models.Action) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *ActionsCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
