//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewActionsGetParams creates a new ActionsGetParams object
// with the default values initialized.
func NewActionsGetParams() *ActionsGetParams {
	var ()
	return &ActionsGetParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewActionsGetParamsWithTimeout creates a new ActionsGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewActionsGetParamsWithTimeout(timeout time.Duration) *ActionsGetParams {
	var ()
	return &ActionsGetParams{

		timeout: timeout,
	}
}

// NewActionsGetParamsWithContext creates a new ActionsGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewActionsGetParamsWithContext(ctx context.Context) *ActionsGetParams {
	var ()
	return &ActionsGetParams{

		Context: ctx,
	}
}

// NewActionsGetParamsWithHTTPClient creates a new ActionsGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewActionsGetParamsWithHTTPClient(client *http.Client) *ActionsGetParams {
	var ()
	return &ActionsGetParams{
		HTTPClient: client,
	}
}

/*ActionsGetParams contains all the parameters to send to the API endpoint
for the actions get operation typically these are written to a http.Request
*/
type ActionsGetParams struct {

	/*ID
	  Unique ID of the Action.

	*/
	ID strfmt.UUID
	/*Include
	  Include additional information, such as classification infos. Allowed values include: classification, _classification, vector, _vector, interpretation, _interpretation

	*/
	Include *string
	/*Meta
	  Should additional meta information (e.g. about classified properties) be included? Defaults to false.

	*/
	Meta *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the actions get params
func (o *ActionsGetParams) WithTimeout(timeout time.Duration) *ActionsGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the actions get params
func (o *ActionsGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the actions get params
func (o *ActionsGetParams) WithContext(ctx context.Context) *ActionsGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the actions get params
func (o *ActionsGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the actions get params
func (o *ActionsGetParams) WithHTTPClient(client *http.Client) *ActionsGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the actions get params
func (o *ActionsGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the actions get params
func (o *ActionsGetParams) WithID(id strfmt.UUID) *ActionsGetParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the actions get params
func (o *ActionsGetParams) SetID(id strfmt.UUID) {
	o.ID = id
}

// WithInclude adds the include to the actions get params
func (o *ActionsGetParams) WithInclude(include *string) *ActionsGetParams {
	o.SetInclude(include)
	return o
}

// SetInclude adds the include to the actions get params
func (o *ActionsGetParams) SetInclude(include *string) {
	o.Include = include
}

// WithMeta adds the meta to the actions get params
func (o *ActionsGetParams) WithMeta(meta *bool) *ActionsGetParams {
	o.SetMeta(meta)
	return o
}

// SetMeta adds the meta to the actions get params
func (o *ActionsGetParams) SetMeta(meta *bool) {
	o.Meta = meta
}

// WriteToRequest writes these params to a swagger request
func (o *ActionsGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID.String()); err != nil {
		return err
	}

	if o.Include != nil {

		// query param include
		var qrInclude string
		if o.Include != nil {
			qrInclude = *o.Include
		}
		qInclude := qrInclude
		if qInclude != "" {
			if err := r.SetQueryParam("include", qInclude); err != nil {
				return err
			}
		}

	}

	if o.Meta != nil {

		// query param meta
		var qrMeta bool
		if o.Meta != nil {
			qrMeta = *o.Meta
		}
		qMeta := swag.FormatBool(qrMeta)
		if qMeta != "" {
			if err := r.SetQueryParam("meta", qMeta); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
