//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// NewActionsPatchParams creates a new ActionsPatchParams object
// with the default values initialized.
func NewActionsPatchParams() *ActionsPatchParams {
	var ()
	return &ActionsPatchParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewActionsPatchParamsWithTimeout creates a new ActionsPatchParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewActionsPatchParamsWithTimeout(timeout time.Duration) *ActionsPatchParams {
	var ()
	return &ActionsPatchParams{

		timeout: timeout,
	}
}

// NewActionsPatchParamsWithContext creates a new ActionsPatchParams object
// with the default values initialized, and the ability to set a context for a request
func NewActionsPatchParamsWithContext(ctx context.Context) *ActionsPatchParams {
	var ()
	return &ActionsPatchParams{

		Context: ctx,
	}
}

// NewActionsPatchParamsWithHTTPClient creates a new ActionsPatchParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewActionsPatchParamsWithHTTPClient(client *http.Client) *ActionsPatchParams {
	var ()
	return &ActionsPatchParams{
		HTTPClient: client,
	}
}

/*ActionsPatchParams contains all the parameters to send to the API endpoint
for the actions patch operation typically these are written to a http.Request
*/
type ActionsPatchParams struct {

	/*Body
	  RFC 7396-style patch, the body contains the action object to merge into the existing action object.

	*/
	Body *models.Action
	/*ID
	  Unique ID of the Action.

	*/
	ID strfmt.UUID

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the actions patch params
func (o *ActionsPatchParams) WithTimeout(timeout time.Duration) *ActionsPatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the actions patch params
func (o *ActionsPatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the actions patch params
func (o *ActionsPatchParams) WithContext(ctx context.Context) *ActionsPatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the actions patch params
func (o *ActionsPatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the actions patch params
func (o *ActionsPatchParams) WithHTTPClient(client *http.Client) *ActionsPatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the actions patch params
func (o *ActionsPatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the actions patch params
func (o *ActionsPatchParams) WithBody(body *models.Action) *ActionsPatchParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the actions patch params
func (o *ActionsPatchParams) SetBody(body *models.Action) {
	o.Body = body
}

// WithID adds the id to the actions patch params
func (o *ActionsPatchParams) WithID(id strfmt.UUID) *ActionsPatchParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the actions patch params
func (o *ActionsPatchParams) SetID(id strfmt.UUID) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *ActionsPatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID.String()); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
