//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// NewActionsReferencesCreateParams creates a new ActionsReferencesCreateParams object
// with the default values initialized.
func NewActionsReferencesCreateParams() *ActionsReferencesCreateParams {
	var ()
	return &ActionsReferencesCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewActionsReferencesCreateParamsWithTimeout creates a new ActionsReferencesCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewActionsReferencesCreateParamsWithTimeout(timeout time.Duration) *ActionsReferencesCreateParams {
	var ()
	return &ActionsReferencesCreateParams{

		timeout: timeout,
	}
}

// NewActionsReferencesCreateParamsWithContext creates a new ActionsReferencesCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewActionsReferencesCreateParamsWithContext(ctx context.Context) *ActionsReferencesCreateParams {
	var ()
	return &ActionsReferencesCreateParams{

		Context: ctx,
	}
}

// NewActionsReferencesCreateParamsWithHTTPClient creates a new ActionsReferencesCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewActionsReferencesCreateParamsWithHTTPClient(client *http.Client) *ActionsReferencesCreateParams {
	var ()
	return &ActionsReferencesCreateParams{
		HTTPClient: client,
	}
}

/*ActionsReferencesCreateParams contains all the parameters to send to the API endpoint
for the actions references create operation typically these are written to a http.Request
*/
type ActionsReferencesCreateParams struct {

	/*Body*/
	Body *models.SingleRef
	/*ID
	  Unique ID of the Action.

	*/
	ID strfmt.UUID
	/*PropertyName
	  Unique name of the property related to the Action.

	*/
	PropertyName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the actions references create params
func (o *ActionsReferencesCreateParams) WithTimeout(timeout time.Duration) *ActionsReferencesCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the actions references create params
func (o *ActionsReferencesCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the actions references create params
func (o *ActionsReferencesCreateParams) WithContext(ctx context.Context) *ActionsReferencesCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the actions references create params
func (o *ActionsReferencesCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the actions references create params
func (o *ActionsReferencesCreateParams) WithHTTPClient(client *http.Client) *ActionsReferencesCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the actions references create params
func (o *ActionsReferencesCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the actions references create params
func (o *ActionsReferencesCreateParams) WithBody(body *models.SingleRef) *ActionsReferencesCreateParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the actions references create params
func (o *ActionsReferencesCreateParams) SetBody(body *models.SingleRef) {
	o.Body = body
}

// WithID adds the id to the actions references create params
func (o *ActionsReferencesCreateParams) WithID(id strfmt.UUID) *ActionsReferencesCreateParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the actions references create params
func (o *ActionsReferencesCreateParams) SetID(id strfmt.UUID) {
	o.ID = id
}

// WithPropertyName adds the propertyName to the actions references create params
func (o *ActionsReferencesCreateParams) WithPropertyName(propertyName string) *ActionsReferencesCreateParams {
	o.SetPropertyName(propertyName)
	return o
}

// SetPropertyName adds the propertyName to the actions references create params
func (o *ActionsReferencesCreateParams) SetPropertyName(propertyName string) {
	o.PropertyName = propertyName
}

// WriteToRequest writes these params to a swagger request
func (o *ActionsReferencesCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID.String()); err != nil {
		return err
	}

	// path param propertyName
	if err := r.SetPathParam("propertyName", o.PropertyName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
