//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// NewActionsReferencesUpdateParams creates a new ActionsReferencesUpdateParams object
// with the default values initialized.
func NewActionsReferencesUpdateParams() *ActionsReferencesUpdateParams {
	var ()
	return &ActionsReferencesUpdateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewActionsReferencesUpdateParamsWithTimeout creates a new ActionsReferencesUpdateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewActionsReferencesUpdateParamsWithTimeout(timeout time.Duration) *ActionsReferencesUpdateParams {
	var ()
	return &ActionsReferencesUpdateParams{

		timeout: timeout,
	}
}

// NewActionsReferencesUpdateParamsWithContext creates a new ActionsReferencesUpdateParams object
// with the default values initialized, and the ability to set a context for a request
func NewActionsReferencesUpdateParamsWithContext(ctx context.Context) *ActionsReferencesUpdateParams {
	var ()
	return &ActionsReferencesUpdateParams{

		Context: ctx,
	}
}

// NewActionsReferencesUpdateParamsWithHTTPClient creates a new ActionsReferencesUpdateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewActionsReferencesUpdateParamsWithHTTPClient(client *http.Client) *ActionsReferencesUpdateParams {
	var ()
	return &ActionsReferencesUpdateParams{
		HTTPClient: client,
	}
}

/*ActionsReferencesUpdateParams contains all the parameters to send to the API endpoint
for the actions references update operation typically these are written to a http.Request
*/
type ActionsReferencesUpdateParams struct {

	/*Body*/
	Body models.MultipleRef
	/*ID
	  Unique ID of the Action.

	*/
	ID strfmt.UUID
	/*PropertyName
	  Unique name of the property related to the Action.

	*/
	PropertyName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the actions references update params
func (o *ActionsReferencesUpdateParams) WithTimeout(timeout time.Duration) *ActionsReferencesUpdateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the actions references update params
func (o *ActionsReferencesUpdateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the actions references update params
func (o *ActionsReferencesUpdateParams) WithContext(ctx context.Context) *ActionsReferencesUpdateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the actions references update params
func (o *ActionsReferencesUpdateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the actions references update params
func (o *ActionsReferencesUpdateParams) WithHTTPClient(client *http.Client) *ActionsReferencesUpdateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the actions references update params
func (o *ActionsReferencesUpdateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the actions references update params
func (o *ActionsReferencesUpdateParams) WithBody(body models.MultipleRef) *ActionsReferencesUpdateParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the actions references update params
func (o *ActionsReferencesUpdateParams) SetBody(body models.MultipleRef) {
	o.Body = body
}

// WithID adds the id to the actions references update params
func (o *ActionsReferencesUpdateParams) WithID(id strfmt.UUID) *ActionsReferencesUpdateParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the actions references update params
func (o *ActionsReferencesUpdateParams) SetID(id strfmt.UUID) {
	o.ID = id
}

// WithPropertyName adds the propertyName to the actions references update params
func (o *ActionsReferencesUpdateParams) WithPropertyName(propertyName string) *ActionsReferencesUpdateParams {
	o.SetPropertyName(propertyName)
	return o
}

// SetPropertyName adds the propertyName to the actions references update params
func (o *ActionsReferencesUpdateParams) SetPropertyName(propertyName string) {
	o.PropertyName = propertyName
}

// WriteToRequest writes these params to a swagger request
func (o *ActionsReferencesUpdateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID.String()); err != nil {
		return err
	}

	// path param propertyName
	if err := r.SetPathParam("propertyName", o.PropertyName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
