//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// ActionsReferencesUpdateReader is a Reader for the ActionsReferencesUpdate structure.
type ActionsReferencesUpdateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ActionsReferencesUpdateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewActionsReferencesUpdateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewActionsReferencesUpdateUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewActionsReferencesUpdateForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewActionsReferencesUpdateUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewActionsReferencesUpdateInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewActionsReferencesUpdateOK creates a ActionsReferencesUpdateOK with default headers values
func NewActionsReferencesUpdateOK() *ActionsReferencesUpdateOK {
	return &ActionsReferencesUpdateOK{}
}

/*ActionsReferencesUpdateOK handles this case with default header values.

Successfully replaced all the references.
*/
type ActionsReferencesUpdateOK struct {
}

func (o *ActionsReferencesUpdateOK) Error() string {
	return fmt.Sprintf("[PUT /actions/{id}/references/{propertyName}][%d] actionsReferencesUpdateOK ", 200)
}

func (o *ActionsReferencesUpdateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewActionsReferencesUpdateUnauthorized creates a ActionsReferencesUpdateUnauthorized with default headers values
func NewActionsReferencesUpdateUnauthorized() *ActionsReferencesUpdateUnauthorized {
	return &ActionsReferencesUpdateUnauthorized{}
}

/*ActionsReferencesUpdateUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type ActionsReferencesUpdateUnauthorized struct {
}

func (o *ActionsReferencesUpdateUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /actions/{id}/references/{propertyName}][%d] actionsReferencesUpdateUnauthorized ", 401)
}

func (o *ActionsReferencesUpdateUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewActionsReferencesUpdateForbidden creates a ActionsReferencesUpdateForbidden with default headers values
func NewActionsReferencesUpdateForbidden() *ActionsReferencesUpdateForbidden {
	return &ActionsReferencesUpdateForbidden{}
}

/*ActionsReferencesUpdateForbidden handles this case with default header values.

Forbidden
*/
type ActionsReferencesUpdateForbidden struct {
	Payload *models.ErrorResponse
}

func (o *ActionsReferencesUpdateForbidden) Error() string {
	return fmt.Sprintf("[PUT /actions/{id}/references/{propertyName}][%d] actionsReferencesUpdateForbidden  %+v", 403, o.Payload)
}

func (o *ActionsReferencesUpdateForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ActionsReferencesUpdateForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewActionsReferencesUpdateUnprocessableEntity creates a ActionsReferencesUpdateUnprocessableEntity with default headers values
func NewActionsReferencesUpdateUnprocessableEntity() *ActionsReferencesUpdateUnprocessableEntity {
	return &ActionsReferencesUpdateUnprocessableEntity{}
}

/*ActionsReferencesUpdateUnprocessableEntity handles this case with default header values.

Request body is well-formed (i.e., syntactically correct), but semantically erroneous. Are you sure the property exists or that it is a class?
*/
type ActionsReferencesUpdateUnprocessableEntity struct {
	Payload *models.ErrorResponse
}

func (o *ActionsReferencesUpdateUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /actions/{id}/references/{propertyName}][%d] actionsReferencesUpdateUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *ActionsReferencesUpdateUnprocessableEntity) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ActionsReferencesUpdateUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewActionsReferencesUpdateInternalServerError creates a ActionsReferencesUpdateInternalServerError with default headers values
func NewActionsReferencesUpdateInternalServerError() *ActionsReferencesUpdateInternalServerError {
	return &ActionsReferencesUpdateInternalServerError{}
}

/*ActionsReferencesUpdateInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type ActionsReferencesUpdateInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *ActionsReferencesUpdateInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /actions/{id}/references/{propertyName}][%d] actionsReferencesUpdateInternalServerError  %+v", 500, o.Payload)
}

func (o *ActionsReferencesUpdateInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ActionsReferencesUpdateInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
