//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package batching

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/semi-technologies/weaviate/entities/models"
)

// BatchingActionsCreateReader is a Reader for the BatchingActionsCreate structure.
type BatchingActionsCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *BatchingActionsCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewBatchingActionsCreateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewBatchingActionsCreateUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewBatchingActionsCreateForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewBatchingActionsCreateUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewBatchingActionsCreateInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewBatchingActionsCreateOK creates a BatchingActionsCreateOK with default headers values
func NewBatchingActionsCreateOK() *BatchingActionsCreateOK {
	return &BatchingActionsCreateOK{}
}

/*BatchingActionsCreateOK handles this case with default header values.

Request succeeded, see response body to get detailed information about each batched item.
*/
type BatchingActionsCreateOK struct {
	Payload []*models.ActionsGetResponse
}

func (o *BatchingActionsCreateOK) Error() string {
	return fmt.Sprintf("[POST /batching/actions][%d] batchingActionsCreateOK  %+v", 200, o.Payload)
}

func (o *BatchingActionsCreateOK) GetPayload() []*models.ActionsGetResponse {
	return o.Payload
}

func (o *BatchingActionsCreateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBatchingActionsCreateUnauthorized creates a BatchingActionsCreateUnauthorized with default headers values
func NewBatchingActionsCreateUnauthorized() *BatchingActionsCreateUnauthorized {
	return &BatchingActionsCreateUnauthorized{}
}

/*BatchingActionsCreateUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type BatchingActionsCreateUnauthorized struct {
}

func (o *BatchingActionsCreateUnauthorized) Error() string {
	return fmt.Sprintf("[POST /batching/actions][%d] batchingActionsCreateUnauthorized ", 401)
}

func (o *BatchingActionsCreateUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewBatchingActionsCreateForbidden creates a BatchingActionsCreateForbidden with default headers values
func NewBatchingActionsCreateForbidden() *BatchingActionsCreateForbidden {
	return &BatchingActionsCreateForbidden{}
}

/*BatchingActionsCreateForbidden handles this case with default header values.

Forbidden
*/
type BatchingActionsCreateForbidden struct {
	Payload *models.ErrorResponse
}

func (o *BatchingActionsCreateForbidden) Error() string {
	return fmt.Sprintf("[POST /batching/actions][%d] batchingActionsCreateForbidden  %+v", 403, o.Payload)
}

func (o *BatchingActionsCreateForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *BatchingActionsCreateForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBatchingActionsCreateUnprocessableEntity creates a BatchingActionsCreateUnprocessableEntity with default headers values
func NewBatchingActionsCreateUnprocessableEntity() *BatchingActionsCreateUnprocessableEntity {
	return &BatchingActionsCreateUnprocessableEntity{}
}

/*BatchingActionsCreateUnprocessableEntity handles this case with default header values.

Request body is well-formed (i.e., syntactically correct), but semantically erroneous. Are you sure the class is defined in the configuration file?
*/
type BatchingActionsCreateUnprocessableEntity struct {
	Payload *models.ErrorResponse
}

func (o *BatchingActionsCreateUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /batching/actions][%d] batchingActionsCreateUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *BatchingActionsCreateUnprocessableEntity) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *BatchingActionsCreateUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBatchingActionsCreateInternalServerError creates a BatchingActionsCreateInternalServerError with default headers values
func NewBatchingActionsCreateInternalServerError() *BatchingActionsCreateInternalServerError {
	return &BatchingActionsCreateInternalServerError{}
}

/*BatchingActionsCreateInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type BatchingActionsCreateInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *BatchingActionsCreateInternalServerError) Error() string {
	return fmt.Sprintf("[POST /batching/actions][%d] batchingActionsCreateInternalServerError  %+v", 500, o.Payload)
}

func (o *BatchingActionsCreateInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *BatchingActionsCreateInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*BatchingActionsCreateBody batching actions create body
swagger:model BatchingActionsCreateBody
*/
type BatchingActionsCreateBody struct {

	// actions
	Actions []*models.Action `json:"actions"`

	// Define which fields need to be returned. Default value is ALL
	Fields []*string `json:"fields"`
}

// Validate validates this batching actions create body
func (o *BatchingActionsCreateBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateActions(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateFields(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *BatchingActionsCreateBody) validateActions(formats strfmt.Registry) error {

	if swag.IsZero(o.Actions) { // not required
		return nil
	}

	for i := 0; i < len(o.Actions); i++ {
		if swag.IsZero(o.Actions[i]) { // not required
			continue
		}

		if o.Actions[i] != nil {
			if err := o.Actions[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("body" + "." + "actions" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var batchingActionsCreateBodyFieldsItemsEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ALL","class","schema","id","creationTimeUnix"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		batchingActionsCreateBodyFieldsItemsEnum = append(batchingActionsCreateBodyFieldsItemsEnum, v)
	}
}

func (o *BatchingActionsCreateBody) validateFieldsItemsEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, batchingActionsCreateBodyFieldsItemsEnum, true); err != nil {
		return err
	}
	return nil
}

func (o *BatchingActionsCreateBody) validateFields(formats strfmt.Registry) error {

	if swag.IsZero(o.Fields) { // not required
		return nil
	}

	for i := 0; i < len(o.Fields); i++ {
		if swag.IsZero(o.Fields[i]) { // not required
			continue
		}

		// value enum
		if err := o.validateFieldsItemsEnum("body"+"."+"fields"+"."+strconv.Itoa(i), "body", *o.Fields[i]); err != nil {
			return err
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *BatchingActionsCreateBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *BatchingActionsCreateBody) UnmarshalBinary(b []byte) error {
	var res BatchingActionsCreateBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
