//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package contextionary_api

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewC11yCorpusGetParams creates a new C11yCorpusGetParams object
// with the default values initialized.
func NewC11yCorpusGetParams() *C11yCorpusGetParams {
	var ()
	return &C11yCorpusGetParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewC11yCorpusGetParamsWithTimeout creates a new C11yCorpusGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewC11yCorpusGetParamsWithTimeout(timeout time.Duration) *C11yCorpusGetParams {
	var ()
	return &C11yCorpusGetParams{

		timeout: timeout,
	}
}

// NewC11yCorpusGetParamsWithContext creates a new C11yCorpusGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewC11yCorpusGetParamsWithContext(ctx context.Context) *C11yCorpusGetParams {
	var ()
	return &C11yCorpusGetParams{

		Context: ctx,
	}
}

// NewC11yCorpusGetParamsWithHTTPClient creates a new C11yCorpusGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewC11yCorpusGetParamsWithHTTPClient(client *http.Client) *C11yCorpusGetParams {
	var ()
	return &C11yCorpusGetParams{
		HTTPClient: client,
	}
}

/*C11yCorpusGetParams contains all the parameters to send to the API endpoint
for the c11y corpus get operation typically these are written to a http.Request
*/
type C11yCorpusGetParams struct {

	/*Corpus
	  A text corpus

	*/
	Corpus C11yCorpusGetBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the c11y corpus get params
func (o *C11yCorpusGetParams) WithTimeout(timeout time.Duration) *C11yCorpusGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the c11y corpus get params
func (o *C11yCorpusGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the c11y corpus get params
func (o *C11yCorpusGetParams) WithContext(ctx context.Context) *C11yCorpusGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the c11y corpus get params
func (o *C11yCorpusGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the c11y corpus get params
func (o *C11yCorpusGetParams) WithHTTPClient(client *http.Client) *C11yCorpusGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the c11y corpus get params
func (o *C11yCorpusGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCorpus adds the corpus to the c11y corpus get params
func (o *C11yCorpusGetParams) WithCorpus(corpus C11yCorpusGetBody) *C11yCorpusGetParams {
	o.SetCorpus(corpus)
	return o
}

// SetCorpus adds the corpus to the c11y corpus get params
func (o *C11yCorpusGetParams) SetCorpus(corpus C11yCorpusGetBody) {
	o.Corpus = corpus
}

// WriteToRequest writes these params to a swagger request
func (o *C11yCorpusGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if err := r.SetBodyParam(o.Corpus); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
