//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package contextionary_api

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// NewC11yExtensionsParams creates a new C11yExtensionsParams object
// with the default values initialized.
func NewC11yExtensionsParams() *C11yExtensionsParams {
	var ()
	return &C11yExtensionsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewC11yExtensionsParamsWithTimeout creates a new C11yExtensionsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewC11yExtensionsParamsWithTimeout(timeout time.Duration) *C11yExtensionsParams {
	var ()
	return &C11yExtensionsParams{

		timeout: timeout,
	}
}

// NewC11yExtensionsParamsWithContext creates a new C11yExtensionsParams object
// with the default values initialized, and the ability to set a context for a request
func NewC11yExtensionsParamsWithContext(ctx context.Context) *C11yExtensionsParams {
	var ()
	return &C11yExtensionsParams{

		Context: ctx,
	}
}

// NewC11yExtensionsParamsWithHTTPClient creates a new C11yExtensionsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewC11yExtensionsParamsWithHTTPClient(client *http.Client) *C11yExtensionsParams {
	var ()
	return &C11yExtensionsParams{
		HTTPClient: client,
	}
}

/*C11yExtensionsParams contains all the parameters to send to the API endpoint
for the c11y extensions operation typically these are written to a http.Request
*/
type C11yExtensionsParams struct {

	/*Extension
	  Description and definition of the concept to extend the contextionary with

	*/
	Extension *models.C11yExtension

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the c11y extensions params
func (o *C11yExtensionsParams) WithTimeout(timeout time.Duration) *C11yExtensionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the c11y extensions params
func (o *C11yExtensionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the c11y extensions params
func (o *C11yExtensionsParams) WithContext(ctx context.Context) *C11yExtensionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the c11y extensions params
func (o *C11yExtensionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the c11y extensions params
func (o *C11yExtensionsParams) WithHTTPClient(client *http.Client) *C11yExtensionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the c11y extensions params
func (o *C11yExtensionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithExtension adds the extension to the c11y extensions params
func (o *C11yExtensionsParams) WithExtension(extension *models.C11yExtension) *C11yExtensionsParams {
	o.SetExtension(extension)
	return o
}

// SetExtension adds the extension to the c11y extensions params
func (o *C11yExtensionsParams) SetExtension(extension *models.C11yExtension) {
	o.Extension = extension
}

// WriteToRequest writes these params to a swagger request
func (o *C11yExtensionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Extension != nil {
		if err := r.SetBodyParam(o.Extension); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
