//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package things

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// NewThingsCreateParams creates a new ThingsCreateParams object
// with the default values initialized.
func NewThingsCreateParams() *ThingsCreateParams {
	var ()
	return &ThingsCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewThingsCreateParamsWithTimeout creates a new ThingsCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewThingsCreateParamsWithTimeout(timeout time.Duration) *ThingsCreateParams {
	var ()
	return &ThingsCreateParams{

		timeout: timeout,
	}
}

// NewThingsCreateParamsWithContext creates a new ThingsCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewThingsCreateParamsWithContext(ctx context.Context) *ThingsCreateParams {
	var ()
	return &ThingsCreateParams{

		Context: ctx,
	}
}

// NewThingsCreateParamsWithHTTPClient creates a new ThingsCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewThingsCreateParamsWithHTTPClient(client *http.Client) *ThingsCreateParams {
	var ()
	return &ThingsCreateParams{
		HTTPClient: client,
	}
}

/*ThingsCreateParams contains all the parameters to send to the API endpoint
for the things create operation typically these are written to a http.Request
*/
type ThingsCreateParams struct {

	/*Body*/
	Body *models.Thing

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the things create params
func (o *ThingsCreateParams) WithTimeout(timeout time.Duration) *ThingsCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the things create params
func (o *ThingsCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the things create params
func (o *ThingsCreateParams) WithContext(ctx context.Context) *ThingsCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the things create params
func (o *ThingsCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the things create params
func (o *ThingsCreateParams) WithHTTPClient(client *http.Client) *ThingsCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the things create params
func (o *ThingsCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the things create params
func (o *ThingsCreateParams) WithBody(body *models.Thing) *ThingsCreateParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the things create params
func (o *ThingsCreateParams) SetBody(body *models.Thing) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *ThingsCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
