//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2020 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ActionsGetResponse actions get response
//
// swagger:model ActionsGetResponse
type ActionsGetResponse struct {
	Action

	// deprecations
	Deprecations []*Deprecation `json:"deprecations"`

	// result
	Result *ActionsGetResponseAO2Result `json:"result,omitempty"`
}

// UnmarshalJSON unmarshals this object from a JSON structure
func (m *ActionsGetResponse) UnmarshalJSON(raw []byte) error {
	// AO0
	var aO0 Action
	if err := swag.ReadJSON(raw, &aO0); err != nil {
		return err
	}
	m.Action = aO0

	// AO1
	var dataAO1 struct {
		Deprecations []*Deprecation `json:"deprecations"`
	}
	if err := swag.ReadJSON(raw, &dataAO1); err != nil {
		return err
	}

	m.Deprecations = dataAO1.Deprecations

	// AO2
	var dataAO2 struct {
		Result *ActionsGetResponseAO2Result `json:"result,omitempty"`
	}
	if err := swag.ReadJSON(raw, &dataAO2); err != nil {
		return err
	}

	m.Result = dataAO2.Result

	return nil
}

// MarshalJSON marshals this object to a JSON structure
func (m ActionsGetResponse) MarshalJSON() ([]byte, error) {
	_parts := make([][]byte, 0, 3)

	aO0, err := swag.WriteJSON(m.Action)
	if err != nil {
		return nil, err
	}
	_parts = append(_parts, aO0)
	var dataAO1 struct {
		Deprecations []*Deprecation `json:"deprecations"`
	}

	dataAO1.Deprecations = m.Deprecations

	jsonDataAO1, errAO1 := swag.WriteJSON(dataAO1)
	if errAO1 != nil {
		return nil, errAO1
	}
	_parts = append(_parts, jsonDataAO1)
	var dataAO2 struct {
		Result *ActionsGetResponseAO2Result `json:"result,omitempty"`
	}

	dataAO2.Result = m.Result

	jsonDataAO2, errAO2 := swag.WriteJSON(dataAO2)
	if errAO2 != nil {
		return nil, errAO2
	}
	_parts = append(_parts, jsonDataAO2)
	return swag.ConcatJSON(_parts...), nil
}

// Validate validates this actions get response
func (m *ActionsGetResponse) Validate(formats strfmt.Registry) error {
	var res []error

	// validation for a type composition with Action
	if err := m.Action.Validate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDeprecations(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateResult(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ActionsGetResponse) validateDeprecations(formats strfmt.Registry) error {

	if swag.IsZero(m.Deprecations) { // not required
		return nil
	}

	for i := 0; i < len(m.Deprecations); i++ {
		if swag.IsZero(m.Deprecations[i]) { // not required
			continue
		}

		if m.Deprecations[i] != nil {
			if err := m.Deprecations[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("deprecations" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ActionsGetResponse) validateResult(formats strfmt.Registry) error {

	if swag.IsZero(m.Result) { // not required
		return nil
	}

	if m.Result != nil {
		if err := m.Result.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("result")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ActionsGetResponse) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ActionsGetResponse) UnmarshalBinary(b []byte) error {
	var res ActionsGetResponse
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ActionsGetResponseAO2Result Results for this specific Action.
//
// swagger:model ActionsGetResponseAO2Result
type ActionsGetResponseAO2Result struct {

	// errors
	Errors *ErrorResponse `json:"errors,omitempty"`

	// status
	// Enum: [SUCCESS PENDING FAILED]
	Status *string `json:"status,omitempty"`
}

// Validate validates this actions get response a o2 result
func (m *ActionsGetResponseAO2Result) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateErrors(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ActionsGetResponseAO2Result) validateErrors(formats strfmt.Registry) error {

	if swag.IsZero(m.Errors) { // not required
		return nil
	}

	if m.Errors != nil {
		if err := m.Errors.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("result" + "." + "errors")
			}
			return err
		}
	}

	return nil
}

var actionsGetResponseAO2ResultTypeStatusPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["SUCCESS","PENDING","FAILED"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		actionsGetResponseAO2ResultTypeStatusPropEnum = append(actionsGetResponseAO2ResultTypeStatusPropEnum, v)
	}
}

const (

	// ActionsGetResponseAO2ResultStatusSUCCESS captures enum value "SUCCESS"
	ActionsGetResponseAO2ResultStatusSUCCESS string = "SUCCESS"

	// ActionsGetResponseAO2ResultStatusPENDING captures enum value "PENDING"
	ActionsGetResponseAO2ResultStatusPENDING string = "PENDING"

	// ActionsGetResponseAO2ResultStatusFAILED captures enum value "FAILED"
	ActionsGetResponseAO2ResultStatusFAILED string = "FAILED"
)

// prop value enum
func (m *ActionsGetResponseAO2Result) validateStatusEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, actionsGetResponseAO2ResultTypeStatusPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ActionsGetResponseAO2Result) validateStatus(formats strfmt.Registry) error {

	if swag.IsZero(m.Status) { // not required
		return nil
	}

	// value enum
	if err := m.validateStatusEnum("result"+"."+"status", "body", *m.Status); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ActionsGetResponseAO2Result) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ActionsGetResponseAO2Result) UnmarshalBinary(b []byte) error {
	var res ActionsGetResponseAO2Result
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
